﻿<!--#include file="inc/CommonsGlobal.asp"-->
<!--#include file="inc/CommonsFrontend.asp"-->
<%
    Dim sNewsletterEmail : sNewsletterEmail = HTMLEncode(Left(Trim(Request("NewsletterEmail")), 100))
    Dim sAction : sAction = Request("Action")

    Dim oConn, sQuery, oQuery
    Set oConn = Server.CreateObject("ADODB.Connection")
    oConn.Open C_CONNECTION_STRING

    If sAction = "Subscribe" or sAction = "Unsubscribe" Then
        If sNewsletterEmail = "" Then
            AddError("Please enter email address.")
        ElseIf Not ValidateEmail(sNewsletterEmail) Then
            AddError("Email <strong>" & sNewsletterEmail & "</strong> is invalid.")
        End If

        If Not IsError() Then
            Dim iNewsltterID
            iNewsltterID = GetValueFromTable(oConn, "NewsletterID", "utb_Newsletters", "WHERE NewsletterTypeID = 2 AND NewsletterEmail = '" & Quote(sNewsletterEmail) & "'")

            Select Case sAction
                Case "Subscribe"
                    If iNewsltterID = "" Then
                        oConn.BeginTrans
                        On Error Resume Next
                        oConn.Execute("INSERT INTO utb_Newsletters(NewsletterTypeID, NewsletterEmail) VALUES(2, '" & Quote(sNewsletterEmail) & "')")
                        If Err.Number = 0 Then
                            oConn.CommitTrans
                            Call SetAlertMessage("success", "Email <strong>" & sNewsletterEmail & "</strong> has been subscribed.")
                            Redirect(GetPageLink("Newsletter"))
                        Else
                            oConn.RollbackTrans
                            AddError(Err.Description)
                        End If
                    Else
                        AddError("Email <strong>" & sNewsletterEmail & "</strong> already exist in database.")
                    End If

                Case "Unsubscribe"
                    If iNewsltterID <> "" Then
                        oConn.BeginTrans
                        On Error Resume Next
                        oConn.Execute("DELETE FROM utb_Newsletters WHERE NewsletterTypeID = 2 AND NewsletterEmail = '" & Quote(sNewsletterEmail) & "'")
                        If Err.Number = 0 Then
                            oConn.CommitTrans
                            Call SetAlertMessage("success", "Email <strong>" & sNewsletterEmail & "</strong> has been unsubscribed.")
                            Redirect(GetPageLink("Newsletter"))
                        Else
                            oConn.RollbackTrans
                            AddError(Err.Description)
                        End If
                    Else
                        AddError("Email <strong>" & sNewsletterEmail & "</strong> doesn't exist in database.")
                    End If
            End Select
        End If
    End If

    Call GetInfoPage(7)
%><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <title><%= sPageTitle %></title>
        <meta name="Description" content="<%= sPageDescription %>" />
        <meta name="Keywords" content="<%= sPageKeywords %>" />
        <!--#include file="inc/HeaderFrontend.asp"-->
    </head>
    <body>
        <!--#include file="inc/TopFrontend.asp"-->
		<div class="breadcrumbs">
			<span class="home">Home:</span>
			<span itemscope="" itemtype="http://data-vocabulary.org/Breadcrumb">
				<a href="<%= GetPageLink("Newsletter") %>" itemprop="url"><span itemprop="title">Newsletter</span></a>
			</span>
		</div>
		<div class="block-clear details-wrap">
			<div class="wpage-title"><h1><%= sInfoPageTitle %></h1></div>
			<% If sInfoPageContent <> "" Then %>
			<div class="wpage-content"><%= sInfoPageContent %></div>
			<hr/>
			<% End If %>
			<!--#include file="inc/Alert.asp"-->
			<form method="post" action="<%= GetPageLink("Newsletter") %>">
				<label for="NewsletterEmailPage">Please provide email address:</label>
				<div style="margin: 3px 0 10px 0">
					<input type="text" name="NewsletterEmail" id="NewsletterEmailPage" value="<%= sNewsletterEmail %>" style="width: 187px" maxlength="100" />
				</div>
				<div>
					<input type="submit" name="action" value="Subscribe" style="font-weight: bold"/>
					&nbsp;&nbsp;&nbsp;
					<input type="submit" name="action" value="Unsubscribe"/>
				</div>
			</form>
		</div>
        <!--#include file="inc/BottomFrontend.asp"-->
    </body>
</html>