<!--#include file="../inc/CommonsGlobal.asp"-->
<!--#include file="inc/CommonsBackend.asp"-->
<%
	Dim iID : iID = Request("ID")
	Dim sAction : sAction = Request("Action")
	Dim sBackURL : sBackURL = GetBackURL("EmailTemplateList.asp")
	If Not ValidateInteger(iID) Then
		Redirect(sBackURL)
	End If
	If GetIndex(sAction, Array("New", "Edit", "Insert", "Update")) = -1 Then 
		Redirect(sBackURL)
	End If
	Dim oConn, sQuery, oQuery
	Set oConn = Server.CreateObject("ADODB.Connection")
	oConn.Open C_CONNECTION_STRING
	Dim sTitle, oEditor
	Dim Name, Subject, Body
	Dim iEmailTemplateID
	Select Case sAction
		Case "New"
			sTitle = "Add Email Template"
			sAction = "Insert"
		Case "Edit"
			sTitle = "Edit Email Template Ref # " & iID
			sAction = "Update"
			Set oQuery = oConn.Execute("SELECT * FROM utb_EmailTemplates WHERE EmailTemplateID = '" & Quote(iID) & "' ")
			If Not oQuery.Eof Then
				Name 	= HTMLEncode(oQuery("EmailTemplateName"))
				Subject = oQuery("EmailTemplateSubject")
				Body 	= oQuery("EmailTemplateBody")
			End If
			oQuery.Close
			Set oQuery = Nothing
		Case "Insert"
			sTitle = "Add Email Template"
			CommonValidation()
			If GetValueFromTable(oConn, "EmailTemplateID", "utb_EmailTemplates", "WHERE EmailTemplateName = '" & Quote(Name) & "'") <> "" Then
				AddError("Email Template with name <strong>" & Name & "</strong> already exist in database.")
			End If
			If Not IsError() Then
				oConn.BeginTrans
				On Error Resume Next
				sQuery = " INSERT INTO utb_EmailTemplates (EmailTemplateName, EmailTemplateSubject, EmailTemplateBody) " & _
						 " VALUES ('" & Quote(Name) & "', '" & Quote(Subject) & "', '" & Quote(Body) & "') "
				oConn.Execute(sQuery)
				iEmailTemplateID = GetLastID(oConn)
				If Err.Number = 0 Then
					oConn.CommitTrans
					Call SetAlertMessage("success", "Email Template has been inserted.")
					Redirect("EmailTemplateForm.asp?Action=Edit&ID=" & iEmailTemplateID)
				Else
					oConn.RollbackTrans
					AddError(Err.Description)
				End If
			End If
		Case "Update"
			sTitle = "Edit Email Template Ref # " & iID
			CommonValidation()
			If GetValueFromTable(oConn, "EmailTemplateID", "utb_EmailTemplates", "WHERE EmailTemplateName = '" & Quote(Name) & "' AND EmailTemplateID <> '" & Quote(iID) & "'") <> "" Then
				AddError("Email Template with name <strong>" & Name & "</strong> already exist in database.")
			End If
			If Not IsError() Then
				oConn.BeginTrans
				On Error Resume Next
				sQuery = " UPDATE utb_EmailTemplates " & _
						 "	SET EmailTemplateName = '" & Quote(Name) & "' " & _
						 "	  , EmailTemplateSubject = '" & Quote(Subject) & "' " & _
						 "	  , EmailTemplateBody = '" & Quote(Body) & "' " & _
						 "  WHERE EmailTemplateID = '" & Quote(iID) & "' "
				oConn.Execute(sQuery)
				iEmailTemplateID = iID
				If Err.Number = 0 Then
					oConn.CommitTrans
					Call SetAlertMessage("success", "Email Template has been updated.")
					Redirect("EmailTemplateForm.asp?Action=Edit&ID=" & iEmailTemplateID)
				Else
					oConn.RollbackTrans
					AddError(Err.Description)
				End If
			End If
	End Select
%><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><%= sPageTitle %></title>
	<meta name="Description" content="<%= sPageDescription %>" />
	<meta name="Keywords" content="<%= sPageKeywords %>" />
	<!--#include file="inc/HeaderBackend.asp"-->
</head>
<body>
<!--#include file="inc/TopBackend.asp"-->
<div class="box-head">
	<a class="head-link-right" href="<%= sBackURL %>"> &laquo; Back</a>
	<h1>Email Templates</h1>
	&nbsp;
</div>
<!--#include file="../inc/Alert.asp"-->
<div class="box-head">
	<h2><%= sTitle %></h2>
</div>
<div class="box">
	<!--#include file="../ckeditor/ckeditor.asp"-->
	<form action="EmailTemplateForm.asp" method="post">
		<input type="hidden" name="Action" value="<%= sAction %>">
		<input type="hidden" name="ID" value="<%= iID %>">
		<table cellpadding="0" cellspacing="0" border="0" class="form-cells">
			<tr>
				<td style="text-align:right;"><span class="asterisk">*</span> Name</td>
				<td><input type="text" class="form-field" name="Name" value="<%= Name %>" style="width:300px;" maxlength="255" /></td>
			</tr>
			<tr>
				<td style="text-align:right;"><span class="asterisk">*</span> Subject</td>
				<td><input type="text" class="form-field" name="Subject" value="<%= Subject %>" style="width:300px;" maxlength="255" /></td>
			</tr>
			<tr>
				<td style="text-align:right;"><span class="asterisk">*</span> Body</td>
				<td>
				<%
					Set oEditor = New CKeditor
					oEditor.basePath = "../ckeditor/"
					oEditor.config("width") = 850
					oEditor.config("height") = 500
					oEditor.editor "Body", Body
				%>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<div style="float:left;"><input type="submit" class="form-btn" value="Save" /></div>
					<div style="float:left;"><input type="reset" class="form-btn" value="Reset" /></div>
				</td>
			</tr>
		</table>
	</form>
</div>
<!--#include file="inc/BottomBackend.asp"-->
</body>
</html>
<%
	Sub CommonValidation()
		Name 	= Trim(Request("Name"))
		Subject = Trim(Request("Subject"))
		Body 	= Trim(Request("Body"))
		If Name = "" Then
			AddError("Field <strong>Name</strong> is required.")
		End If
		If Subject = "" Then
			AddError("Field <strong>Subject</strong> is required.")
		End If
		If Body = "" Then
			AddError("Field <strong>Body</strong> is required.")
		End If
	End Sub
%>